## camljava 0.3

=== Makefile ===
all:
	cd lib; $(MAKE) all

install:
	cd lib; $(MAKE) install

tst:
	cd test; $(MAKE)

clean:
	cd lib; $(MAKE) clean
	cd test; $(MAKE) clean

=== lib/Makefile ===
include ../Makefile.config

OCAMLC=ocamlc -g
OCAMLOPT=ocamlopt
OCAMLDEP=ocamldep
OCAMLLIB=`ocamlc -where`
CAMLJAVALIB=$(OCAMLLIB)/camljava

all: jni.cma jni.cmxa javaclasses

install:
	mkdir -p $(CAMLJAVALIB)
	cp jni.cma jni.cmi jni.cmxa jni.a libcamljni.a jni.mli $(CAMLJAVALIB)
	jar cf $(CAMLJAVALIB)/camljava.jar fr/inria/caml/camljava/*.class

jni.cma: jni.cmo libcamljni.a
	$(OCAMLC) -linkall -a -o jni.cma -custom jni.cmo \
            -ccopt "$(JNILIBOPTS)" -cclib -lcamljni -cclib "$(JNILIBS)"

jni.cmxa: jni.cmx libcamljni.a
	$(OCAMLOPT) -linkall -a -o jni.cmxa jni.cmx \
            -ccopt "$(JNILIBOPTS)" -cclib -lcamljni -cclib "$(JNILIBS)"

libcamljni.a: jnistubs.o
	rm -f libcamljni.a
	ar rcs libcamljni.a jnistubs.o

clean::
	rm -f libcamljni.a

jni.ml: jni.mlp jni.mli ../Makefile.config
	rm -f jni.ml
	sed -e 's|%PATH%|'$(CAMLJAVALIB)/camljava.jar'|' \
                jni.mlp > jni.ml
	chmod -w jni.ml

clean::
	rm -f jni.ml

beforedepend:: jni.ml

javaclasses:
	$(JAVAC) fr/inria/caml/camljava/*.java

clean::
	rm -f fr/inria/caml/camljava/*.class

clean::
	rm -f *.cm? *.[oa]

.SUFFIXES: .ml .mli .cmo .cmi .cmx

.c.o:
	$(CC) -c $(CFLAGS) $(JNIINCLUDES) -I$(OCAMLLIB) $*.c

.ml.cmo:
	$(OCAMLC) -c $*.ml

.ml.cmx:
	$(OCAMLOPT) -c $*.ml

.mli.cmi:
	$(OCAMLC) -c $*.mli

depend: beforedepend
	$(OCAMLDEP) *.mli *.ml > .depend

include .depend

=== test/Makefile ===
include ../Makefile.config

CAMLJAVA=`ocamlc -where`/camljava/camljava.jar

all: jnitest Test.class Testcb.class
	./jnitest

jnitest: jnitest.ml
	ocamlc -ccopt -g -o jnitest -I +camljava jni.cma jnitest.ml

clean::
	rm -f jnitest

.SUFFIXES: .java .class

.java.class:
	$(JAVAC) -classpath $(CAMLJAVA):. $*.java

clean::
	rm -f *.cm?

=== debian/changelog ===
camljava (0.3-5) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload

  [ Debian Janitor ]
  * Use secure URI in Homepage field
  * Set upstream metadata fields: Repository-Browse
  * Update standards version to 4.6.1

 -- Stéphane Glondu <glondu@debian.org>  Sat, 02 Sep 2023 10:13:46 +0200

camljava (0.3-4) unstable; urgency=medium

  * Team upload
  * Do not link jni.cma with -custom (Closes: #973181)
  * Bump Standards-Version to 4.6.0
  * Update debian/watch: bump version to 4, point to new upstream location

 -- Stéphane Glondu <glondu@debian.org>  Mon, 03 Jan 2022 15:47:32 +0100

camljava (0.3-3) unstable; urgency=medium

  * Team upload
  * Remove Stefano from Uploaders
  * Update Vcs-* to point to salsa
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no
  * Switch copyright format to 1.0

 -- Stéphane Glondu <glondu@debian.org>  Fri, 24 Jul 2020 11:51:17 +0200

camljava (0.3-2) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Update Vcs-*
  * Bump debhelper compat to 10
  * Switch source package format to 3.0 (quilt)

  [ Dimitri John Ledkov ]
  * Cherrypick upstream patch to use jlong instead of int64, fixes FTBFS
    with ocaml 4.04.

 -- Stéphane Glondu <glondu@debian.org>  Tue, 18 Jul 2017 09:40:41 +0200

camljava (0.3-1) unstable; urgency=low

  * Initial Release (Closes: #558090).

 -- Stefano Zacchiroli <zack@debian.org>  Tue, 01 Dec 2009 11:19:13 +0100

=== debian/control ===
Source: camljava
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 default-jdk,
 ocaml-findlib,
 dh-ocaml
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ocaml-team/camljava.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/camljava
Homepage: https://pauillac.inria.fr/~xleroy/software.html#camljava

Package: libcamljava-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 default-jdk,
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: interface between OCaml and Java via Caml/C interface and JNI
 CamlJava is an interface between OCaml and Java allowing programs written in
 one of the two languages to call code written in the other.
 .
 Interaction among the two languages happen via the respective C interfaces:
 Caml/C interface for OCaml and JNI (Java Native Interface) for Java.
 .
 Currently, CamlJava provides a low-level, weakly-typed OCaml interface very
 similar to the JNI. Java object references are mapped to an abstract type, and
 various JNI-like operations are provided to allow Java method invocation,
 field access, and more.
 .
 A basic callback facility (allowing Java code to invoke methods on OCaml
 objects) is also provided, although some stub Java code must be written by
 hand.
 .
 This package contain all the development stuff needed to use CamlJava from
 OCaml programs.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

PKGNAME = libcamljava-ocaml-dev
DESTDIR := $(CURDIR)/debian/$(PKGNAME)/$(OCAML_STDLIB_DIR)/camljava

DEFJAVA_DIR = /usr/lib/jvm/default-java

# /usr/lib/jvm/default-java/jre/lib/amd64/server/libjvm.so -> amd64
# XXX horrible way to retrieve Java arch, but unfortunately there is no
# reliable mapping available yet (see #558109)
JAVA_ARCH := $(shell find $(DEFJAVA_DIR)/ -path '*jre/lib/*/server/libjvm.so' | cut -f 8 -d /)

BUILD_TARGET_FLAGS = JDKHOME=$(DEFJAVA_DIR)
BUILD_TARGET_FLAGS += ARCH=$(JAVA_ARCH)
DEB_MAKE_INSTALL_TARGET = install CAMLJAVALIB=$(DESTDIR)
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
DEB_MAKE_BUILD_TARGET = all $(BUILD_TARGET_FLAGS)
else
DEB_MAKE_BUILD_TARGET = byte $(BUILD_TARGET_FLAGS)
endif

%:
	dh $@ --with-ocaml

override_dh_auto_build:
	$(MAKE) $(DEB_MAKE_BUILD_TARGET)

override_dh_auto_install:
	$(MAKE) $(DEB_MAKE_INSTALL_TARGET)

## camljava 0.4

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,7 @@
 all:
 	cd lib; $(MAKE) all
+byte:
+	cd lib; $(MAKE) byte
 
 install:
 	cd lib; $(MAKE) install

=== lib/Makefile ===
--- 
+++ 
@@ -6,12 +6,12 @@
 OCAMLLIB=`ocamlc -where`
 CAMLJAVALIB=$(OCAMLLIB)/camljava
 
-all: jni.cma jni.cmxa javaclasses
+all: jni.cma jni.cmxa camljava.jar
+byte: jni.cma camljava.jar
 
 install:
 	mkdir -p $(CAMLJAVALIB)
-	cp jni.cma jni.cmi jni.cmxa jni.a libcamljni.a jni.mli $(CAMLJAVALIB)
-	jar cf $(CAMLJAVALIB)/camljava.jar fr/inria/caml/camljava/*.class
+	cp jni.cma jni.cmi $(wildcard jni.cmxa jni.a) libcamljni.a jni.mli camljava.jar $(CAMLJAVALIB)
 
 jni.cma: jni.cmo libcamljni.a
 	$(OCAMLC) -linkall -a -o jni.cma -custom jni.cmo \
@@ -39,6 +39,12 @@
 
 beforedepend:: jni.ml
 
+camljava.jar: javaclasses
+	jar cf camljava.jar fr/inria/caml/camljava/*.class
+
+clean::
+	rm -f camljava.jar
+
 javaclasses:
 	$(JAVAC) fr/inria/caml/camljava/*.java
 
@@ -46,7 +52,7 @@
 	rm -f fr/inria/caml/camljava/*.class
 
 clean::
-	rm -f *.cm? *.[oa]
+	rm -f *.cm? *.[oa] *.cmxa
 
 .SUFFIXES: .ml .mli .cmo .cmi .cmx

=== test/Makefile ===
include ../Makefile.config

CAMLJAVA_PATH=../lib/camljava.jar
CAMLJAVA_DIR=../lib

#CAMLJAVA_PATH=`ocamlc -where`/camljava/camljava.jar
#CAMLJAVA_DIR=+camljava

all: jnitest Test.class Testcb.class
	CLASSPATH=$(CAMLJAVA_PATH):. ./jnitest

jnitest: jnitest.ml
	ocamlc -ccopt -g -o jnitest -I $(CAMLJAVA_DIR) jni.cma jnitest.ml

clean::
	rm -f jnitest

.SUFFIXES: .java .class

.java.class:
	$(JAVAC) -classpath $(CAMLJAVA_PATH):. $*.java

clean::
	rm -f *.cm?
	rm -f *.class

=== debian/changelog ===
camljava (0.4-2build7) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 02 Jul 2025 06:17:50 +0200

camljava (0.4-2build6) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 16 Jun 2025 14:52:32 +0200

camljava (0.4-2build5) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 28 Jan 2025 19:37:05 +0100

camljava (0.4-2build4) oracular; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 13 Aug 2024 10:45:33 +0200

camljava (0.4-2build3) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 12 Aug 2024 09:40:11 +0200

camljava (0.4-2build2) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 12 Aug 2024 09:34:29 +0200

camljava (0.4-2build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:09:06 +0200

camljava (0.4-2) unstable; urgency=medium

  * Team upload
  * Fix compilation with OCaml 5.x

 -- Stéphane Glondu <glondu@debian.org>  Sun, 04 Aug 2024 09:18:33 +0200

camljava (0.4-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Fix typo in call to dh (Closes: #1076614)
  * Bump Standards-Version to 4.7.0

 -- Stéphane Glondu <glondu@debian.org>  Sat, 20 Jul 2024 09:41:58 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  default-jdk,
  ocaml-findlib,
  dh-ocaml
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/camljava.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/camljava

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 endif
 
 %:
-	dh $@ --with-ocaml
+	dh $@ --with=ocaml
 
 override_dh_auto_build:
 	$(MAKE) $(DEB_MAKE_BUILD_TARGET)

=== debian/watch ===
version=4
opts=uversionmangle=s/(.)(.)/$1.$2/ \
https://github.com/xavierleroy/camljava/tags .*/camljava(\d\d)\.tar\.gz
